; By Wenlei Chen      Oct 2013 
; Need IDL_ASTRO_LIBRARY
; Subroutine of Fermi_Filter_Main.pro

FUNCTION Fermi_Mask_Source, data_arr, FHL, n_rows
print, 'Filtering...'
output_tmp = dblarr(7,n_rows)
n_photon = 0L
i = 0L
n = N_elements(FHL)/2
WHILE i ne n_rows DO BEGIN 
  flag1 = 0
  flag2 = 0
  ra  = data_arr(1,i)/180.*!PI
  dec = data_arr(2,i)/180.*!PI
  FOR j = 0, n-1 DO BEGIN
    ra0 = FHL(0,j)/180.*!PI
    dec0 = FHL(1,j)/180.*!PI
    d_theta = acos(sin(dec)*sin(dec0)+cos(dec)*cos(dec0)*cos(ra-ra0))
    IF d_theta LT 1.5/180.*!PI THEN BEGIN
      flag1 = 1
    ENDIF
  ENDFOR
  IF data_arr(4,i) LT 50 and data_arr(4,i) GT -50 THEN BEGIN
    flag2 = 1
  ENDIF
  IF flag1 EQ 0 and flag2 EQ 0 THEN BEGIN
    output_tmp(*,n_photon) = data_arr(*,i)
    n_photon++
  ENDIF
  i++
ENDWHILE
output_arr = dblarr(7,n_photon)
n = 0L
WHILE n ne n_photon DO BEGIN
  output_arr(*,n) = output_tmp(*,n)
  n++
ENDWHILE
RETURN, output_arr
END